{****************************************************************************

                   Copyright (c) 1993,94 by Florian Klmpfl

 ****************************************************************************}

{$M 32000,16384,655360}

program pp;

  uses
     globals,parser,dos,scanner,asmgen,symtable,objects,tree;

  const
     copyright = 'Copyright (c) 1993,94 by FP Klmpfl';

     released = {$I C:\PASDATE.INC}; { released sollte ein String mit     }
                                     { dem aktuellen Datum sein,          }
                                     { bei mir wird PASDATE.INC jeden Tag }
                                     { neu in der AUTOEXEC.BAT erzeugt    }

  var
     asmfilename : pathstr;

  procedure error(const s : string);

    begin
       writeln('Fehler: ',s);
       halt(1);
    end;

  procedure init;

    var
       s,opts : string;
       p : pathstr;
       d : dirstr;
       n : namestr;
       e : extstr;
       i,j : integer;
       resf : text;
       res,endofparas : boolean;

    procedure illparas;

      begin
         write('Illegaler Parameter: ',opts);
         writeln('  Aufruf mit -? gibt Liste der Optionen aus');
         halt(1);
      end;

    procedure printhilfe;

      var
         s : string;

      begin
         writeln('PP [Optionen] <inputfile> [Optionen]');
         writeln('  + schaltet eine Option ein, - ab');
         writeln('  mit * markierte Optionen haben momentan keine Wirkung');
         writeln('  mit ! markierte Optionen nur teilweise implementiert');
         writeln('  -a+   Ausgabe einer Assemblerdatei');
         writeln('  -b+   Der Compiler benutzt EMS => geringere Geschwindigkeit');
         writeln('* -B    Browseroptionen');
         writeln('           * -Ba alle Informationen');
         writeln('           * -Bg globale Informationen');
         writeln('           * -Bl lokale Informationen');
         writeln('  -C     Codegeneratoroptionen');
         writeln('           * -Ca automatischer Aufruf von Kon- und Destruktoren');
         writeln('           * -Ce es werden keine Laufzeit-Fehler generiert,');
         writeln('                 sondern stattdessen Exceptions erzeugt');
         writeln('             -Chxxxx  xxxx gibt die maximale Heapgre in Bytes an ');
         writeln('                 (mu kleiner 67107840 und grer 1023 sein; 4000000 Default)');
         writeln('             -Co testet auf berlufe bei Integer-Operationen');
         writeln('             -Cr Test auf Bereichsberschreitungen');
         writeln('             -Cs xxxx gibt die maximale Stackgre in Bytes an (nur OS/2)');
         writeln('                 (mu kleiner 67107840 und grer 1023 sein; 8096 Default)');
         writeln('  -dxxx  definiert das Symbol xxx');
         writeln;
         writeln;
         writeln;
         write('*** Weiter mit Return. ***');
         readln(s);
         writeln('  -D     steuert die Erzeugung einer DEF-Datei unter OS/2');
         writeln('             -Ddxxxx xxxx ist Beschreibung');
         writeln('             -Do erzeuge DEF-Datei');
         writeln('             -Dw PM-Anwendung');
         writeln('  -g     Es werden Debuggerinformationen erzeugt');
         writeln('  -l     Ausgabe des Programmlogos');
         writeln('  -i     Programminformation');
         writeln('  -m     Der Compiler erzeugt ein Makefile mit Eingabedatei.mak als Namen');
         writeln('  -O     Optimiereroptionen');
         writeln('             -Oa einfache Optimierungen');
         writeln('             -Og Optimierung auf Gre');
         writeln('             -OG Optimierung auf Geschwindigkeit');
         writeln('             -Ox maximale Optimierung');
         writeln('  -q-    Der Compiler zeigt die Fortschritte beim bersetzten an');
         writeln('  -S     Syntaxoptionen');
         writeln('             -Sa Einstellung der Ausdruckbehandlung');
         writeln('                 eine hheres Level schliet die unteren ein');
         writeln('                 -Sa0 nur ANSI-Pascalausdrcke erlaubt');
         writeln('                 -Sa1 Funktionsresultate muessen nicht zugewiesen werden');
         writeln('                 -Sa2 @-Operator liefert einen typisierten Pointer');
         writeln('                 -Sa4 typisierte Zuweisungsrckgabewerte');
         writeln('                 -Sa9 auch seiteneffektlose Ausdrcke erlaubt');
         writeln('             -Sn Keine Exceptionuntersttzung');
         writeln;
         write('*** Weiter mit Return. ***');
         readln(s);
         writeln('          *  -Ss der Name von Konstruktoren mu immer init sein');
         writeln('                 der Name von Destruktoren mu immer done sein');
         writeln('  -T     Zielbetriebssystem');
         writeln('             -TDOS DOS-Extender von DJ Delorie');
         writeln('             -TOS2 OS/2 2.x');
         writeln('          !  -TLINUX Linux');
         writeln('          !  -TWin32 Windows 32 Bit');
         writeln('  -U     Unit-Optionen');
         writeln('             -Ue mit ERRORLEVEL=255 anzeigen wenn eine Unit bersetzt wurde');
         writeln('             -Us eine System-Unit wird bersetzt');
         writeln;
         writeln('  -h,-?  zeigt diesen Hilfebildschirm');
         halt(1);
      end;

    procedure getparastring;

      begin
         endofparas:=false;
         if res then
           begin
              readln(resf,opts);
              if eof(resf) then
                begin
                   close(resf);
                   res:=false;
                end
           end
         else
           begin
              if i<paramcount then
                begin
                   inc(i);
                   if i=paramcount then
                     endofparas:=true;
                   opts:=paramstr(i);
                   if opts[1]='@' then
                     begin
                        res:=true;
                        assign(resf,copy(opts,2,length(opts)-1));
                        reset(resf);
                        getparastring;
                     end;
                end;
           end;
      end;

    procedure info;

      begin
         writeln('FPKPascal  Version ',version,'    ',copyright);
         writeln('Freigegeben am: ',released);
         writeln;
         writeln('Compiler: FP Klmpfl');
         writeln('Runtime-Library: FP Klmpfl und MH Spiegel');
         {writeln('Editor:                      **********');}
         writeln;
         writeln('Dieses Programm darf verwenden, verndert und weiter-');
         writeln('gegebenwerden, solange daraus niemand finanzielle Vorteile');
         writeln('entstehen. Beim Weitergeben darf eine Kopiergebhr');
         writeln('von maximal 15 DM verlangt werden (inkl. aller dazu-');
         writeln('gehrigen Leistungen wie Datentrger...)');
         writeln('Sollte das Programm kommerziell eingesetzt werden,');
         writeln('so ist mit mir zwecks Lizenzgebhren Verbindung');
         writeln('aufzunehmen. Adresse siehe unten');
         writeln;
         writeln('Wenn Sie im Programm einen Fehler entdecken oder ');
         writeln('Verbesserungsvorschlge haben, so informieren Sie');
         writeln('bitte mich (Fehler bitte mit Angabe der Compiler-');
         writeln('version und problematischem Quelltext):');
         writeln;
         writeln('              Florian Klmpfl');
         writeln('              Feldstr. 4');
         writeln('        91096 Mhrendorf');
         writeln('              Deutschland');
         halt(1);
      end;

    procedure setbool(var b : boolean);

      begin
         if length(opts)=2 then b:=true
         else if length(opts)=3 then
            begin
               if opts[3]='+' then b:=true
               else if opts[3]='-' then b:=false
               else illparas;
            end
         else illparas;
      end;

    var
       code : word;
       hs : string;
       as_res : text;
       mac : pmacrosym;

    begin
       objext:='.o';
       res:=false;
       i:=0;
       p:='';
       if paramcount=0 then printhilfe;
       endofparas:=false;
       while not(endofparas) do
         begin
            getparastring;
            if (opts[1]='-') then
              begin
                 case opts[2] of
                    'h','?' : if length(opts)=2 then printhilfe else illparas;
                    'a'     : setbool(writeasmfile);
                    'b'     : setbool(use_big);
                    'B'     : begin
                                 for j:=3 to length(opts) do
                                 case opts[j] of
                                     'a' : ;
                                     'g' : ;
                                     'l' : ;
                                     else illparas;
                                 end;
                              end;
                    'C'     : begin
                                 for j:=3 to length(opts) do
                                 case opts[j] of
                                     'a' : ;
                                     'e' : ;
                                     'h' : begin
                                              val(copy(opts,j+1,length(opts)-j),heapsize,code);
                                              if (code<>0) or (heapsize>=67107840) or
                                                (heapsize<1024) then
                                                illparas;
                                              break;
                                           end;
                                     'o' : check_overflow:=true;
                                     'r' : rangechecking:=true;
                                     's' : begin
                                              val(copy(opts,j+1,length(opts)-j),stacksize,code);
                                              if (code<>0) or (stacksize>=67107840) or
                                                (stacksize<1024) then
                                                illparas;
                                              break;
                                           end;
                                     else illparas;
                                 end;
                              end;
                    'd'     : begin
                                 mac:=new(pmacrosym,init(copy(opts,3,255)));
                                 mac^.defined:=true;
                                 macros^.insert(mac);
                              end;
                    'D'     : begin
                                 for j:=3 to length(opts) do
                                 case opts[j] of
                                     'd' : begin
                                              description:=copy(opts,j+1,length(opts)-j);
                                              break;
                                           end;
                                     'o' : gendeffile:=true;
                                     'w' : genpm:=true;
                                     else illparas;
                                 end;
                              end;
                    'g'     : setbool(debuginfo);
                    'i'     : info;
                    'l'     : begin
                                 writeln('FPKPascal  Version ',version,' vom ',released);
                                 writeln(copyright);
                                 if length(opts)<>2 then
                                   illparas;
                              end;
                    'q'     : setbool(quiet);
                    'm'     : setbool(gen_makefile);
                    'O'     : begin
                                 for j:=3 to length(opts) do
                                 case opts[j] of
                                    'a' : optimiere:=true;
                                    'g' : littlesize:=true;
                                    'G' : littlesize:=false;
                                    'x' : begin
                                             maxoptimieren:=true;
                                             optimiere:=true;
                                          end;
                                    else illparas;
                                 end;
                              end;
                    'S'     : begin
                                 for j:=3 to length(opts) do
                                   case opts[j] of
                                     'a' : begin
                                              if j<length(opts) then inc(j)
                                                else illparas;
                                              val(opts[j],exprlevel,code);
                                              if code<>0 then
                                                illparas;
                                           end;
                                     'n' : genexceptcode:=false;
                                     's' : ;
                                     else illparas;
                                   end;
                              end;
                    'T'     : begin
                                 hs:='';
                                 for j:=3 to length(opts) do
                                   hs:=hs+upcase(opts[j]);
                                 objext:='.o';
                                 if hs='DOS' then
                                   target:=target_DOS
                                 else if hs='OS2' then
                                   begin
                                      target:=target_OS2;
                                      objext:='.obj';
                                   end
                                 else if hs='LINUX' then
                                   target:=target_LINUX
                                 else if hs='WIN32' then
                                   target:=target_WIN32
                                 else illparas;
                              end;
                    'U'     : begin
                                 for j:=3 to length(opts) do
                                   case opts[j] of
                                     'e' : errorlev:=true;
                                     's' : compilesystem:=true;
                                     else illparas;
                                   end;
                              end;
                    else illparas;
                 end
              end
            else if opts[1]='@' then
              begin
                 writeln('Response-Dateiangaben in Response-Dateien werden nicht untersttzt');
                 halt(1);
              end
            else
              begin
                 if length(p)<>0 then
                   error('Es kann nur eine Quelldatei angegeben werden');
                 p:=opts;
              end;
         end;
       if p='' then
         error('Keine Eingabedatei angegeben');
       fsplit(p,d,n,e);
       if e='' then e:='.PP';
       inputfile:=d+n;
       inputdir:=d;
       asmfilename:=inputfile+'.S';
       assign(asmfile,asmfilename);
       assign(as_res,'AS.RES');
       rewrite(as_res);
       writeln(as_res,'-o ',inputfile+objext+' '+asmfilename);
       close(as_res);
       if gen_makefile then
         begin
            assign(makefile,inputfile+'.MAK');
            {$I-}
            rewrite(makefile);
            {$I+}
            if ioresult<>0 then
              error('Makedatei kann nicht erzeugt werden');
         end;
       if gendeffile then
         begin
            if target<>target_OS2 then
              error('DEF-Datei kann nur fr OS/2 erzeugt werden');
            assign(defdatei,inputfile+'.DEF');
            {$I-}
            rewrite(defdatei);
            {$I+}
            if ioresult<>0 then
              error('DEF-Datei kann nicht erzeugt werden');
            write(defdatei,'NAME '+upper(inputfile));
            if genpm then
              write(defdatei,' WINDOWAPI');
            writeln(defdatei,#13#10#13#10'PROTMODE'#13#10);
            writeln(defdatei,'DESCRIPTION '+''''+description+''''#13#10);
            writeln(defdatei,'DATA'#9'MULTIPLE'#13#10);
            writeln(defdatei,'STACKSIZE'#9+tostr(stacksize));
            writeln(defdatei,'HEAPSIZE'#9+tostr(heapsize)+#13#10);
            write(defdatei,'EXPORTS');
         end;
    end;

  function getrealtime : real;

    var
       h,m,s,s100 : word;

    begin
       gettime(h,m,s,s100);
       getrealtime:=h*3600.0+m*60.0+s+s100/100.0;
    end;

  var
     starttime : single;
     data_size : longint;
     hs1 : namestr;
     hs2 : extstr;
     start : real;
     oldexit : pointer;

  procedure myexit;far;

    begin
       if gendeffile then
         close(defdatei);
       if use_big then
         symbolstream.done;
       exitproc:=oldexit;
    end;

  procedure do_streamerror;far;

    begin
       writeln('Fehler ',symbolstream.status,' bei der Nutzung von EMS');
       halt(1);
    end;

begin
   start:=getrealtime;
   { einige Units initialisieren }
   init_tree;
   init_symtable;
   fsplit(paramstr(0),unitpath,hs1,hs2);
   globalsinit;
   init;
   if use_big then
     begin
        symbolstream.init(10000,4000000);
        if symbolstream.errorinfo=stiniterror then
          do_streamerror;
        { Kein String darf die Position 0 haben, da dies ein nil-Pointer ist }
        { irgendetwas schreiben: }
        symbolstream.writestr(@inputfile);
        streamerror:=@do_streamerror;
     end;
   oldexit:=exitproc;
   exitproc:=@myexit;
   writeln(upper(inputfile)+'.PP');
   initscanner(inputfile+'.PP');
   asmgeninit;
   data_size:=parse;
   if not(quiet) then
     begin
        if codegeneration then
          begin
             if writeasmfile then
               write(asmlines,' Zeilen erzeugt, ');
             write(abslines,' Zeilen bersetzt, ');
             write(getrealtime-start:0:1,' Sek., ');
             write(data_size, ' Bytes Daten');
             if compiling_a_unit then
               write(', ',unitsize,' Bytes PPU-Datei');
             writeln;
          end
        else
          begin
             write(errorcount,' Fehler');
             writeln;
             halt(1);
          end;
     end;
   { errorlevel=0, wenn auch wirklich Code erzeugt wurde }
   if codegeneration then
     begin
        { durch errorlevel=255 anzeigen, falls ntig anzeigen, wenn eine }
        { Unit bersetzt wurde                                           }
        if compiling_a_unit and errorlev then
          halt(255)
        else
          halt(0);
     end
   else halt(1);
end.
